Index: serefpolicy-contrib-20140730/virt.if
===================================================================
--- serefpolicy-contrib-20140730.orig/virt.if
+++ serefpolicy-contrib-20140730/virt.if
@@ -860,74 +695,265 @@ interface(`virt_read_lib_files',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_lib_files',`
+interface(`virt_manage_cache',`
+	gen_require(`
+		type virt_cache_t;
+	')
+
+	files_search_var($1)
+	manage_dirs_pattern($1, virt_cache_t, virt_cache_t)
+	manage_files_pattern($1, virt_cache_t, virt_cache_t)
+	manage_lnk_files_pattern($1, virt_cache_t, virt_cache_t)
+')
+
+########################################
+## <summary>
+##	Allow domain to manage virt image files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`virt_manage_images',`
 	gen_require(`
 		type virt_var_lib_t;
+		attribute virt_image_type;
 	')
 
-	files_search_var_lib($1)
-	manage_files_pattern($1, virt_var_lib_t, virt_var_lib_t)
+	virt_search_lib($1)
+	allow $1 virt_image_type:dir list_dir_perms;
+	manage_dirs_pattern($1, virt_image_type, virt_image_type)
+	manage_files_pattern($1, virt_image_type, virt_image_type)
+	read_lnk_files_pattern($1, virt_image_type, virt_image_type)
+	rw_blk_files_pattern($1, virt_image_type, virt_image_type)
+	rw_chr_files_pattern($1, virt_image_type, virt_image_type)
+')
+
+#######################################
+## <summary>
+##  Allow domain to manage virt image files
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`virt_manage_default_image_type',`
+    gen_require(`
+        type virt_var_lib_t;
+        type virt_image_t;
+    ')
+
+    virt_search_lib($1)
+    manage_dirs_pattern($1, virt_image_t, virt_image_t)
+    manage_files_pattern($1, virt_image_t, virt_image_t)
+    read_lnk_files_pattern($1, virt_image_t, virt_image_t)
 ')
 
 ########################################
 ## <summary>
-##	Create objects in virt pid
-##	directories with a private type.
+##	Execute virt server in the virt domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`virt_systemctl',`
+	gen_require(`
+		type virtd_unit_file_t;
+		type virtd_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 virtd_unit_file_t:file read_file_perms;
+	allow $1 virtd_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, virtd_t)
+')
+
+########################################
+## <summary>
+##	Ptrace the svirt domain
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`virt_ptrace',`
+	gen_require(`
+		attribute virt_domain;
+	')
+
+	allow $1 virt_domain:process ptrace;
+')
+
+#######################################
+## <summary>
+##	Execute Sandbox Files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="private type">
+#
+interface(`virt_exec_sandbox_files',`
+	gen_require(`
+		type svirt_sandbox_file_t;
+	')
+
+	can_exec($1, svirt_sandbox_file_t)
+')
+
+#######################################
+## <summary>
+##	Manage Sandbox Files
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The type of the object to be created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object">
+#
+interface(`virt_manage_sandbox_files',`
+	gen_require(`
+		type svirt_sandbox_file_t;
+	')
+
+	manage_dirs_pattern($1, svirt_sandbox_file_t, svirt_sandbox_file_t)
+	manage_files_pattern($1, svirt_sandbox_file_t, svirt_sandbox_file_t)
+	manage_fifo_files_pattern($1, svirt_sandbox_file_t, svirt_sandbox_file_t)
+	manage_chr_files_pattern($1, svirt_sandbox_file_t, svirt_sandbox_file_t)
+	manage_lnk_files_pattern($1, svirt_sandbox_file_t, svirt_sandbox_file_t)
+')
+
+#######################################
+## <summary>
+##	Relabel Sandbox File systems
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The object class of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="name" optional="true">
+#
+interface(`virt_relabel_sandbox_filesystem',`
+	gen_require(`
+		type svirt_sandbox_file_t;
+	')
+
+	allow $1 svirt_sandbox_file_t:filesystem { relabelfrom relabelto };
+')
+
+#######################################
+## <summary>
+##	Mounton Sandbox Files
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	The name of the object being created.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <infoflow type="write" weight="10"/>
 #
-interface(`virt_pid_filetrans',`
+interface(`virt_mounton_sandbox_file',`
 	gen_require(`
-		type virt_var_run_t;
+		type svirt_sandbox_file_t;
+	')
+
+	allow $1 svirt_sandbox_file_t:dir_file_class_set mounton;
+')
+
+#######################################
+## <summary>
+##	Connect to virt over a unix domain stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`virt_stream_connect_sandbox',`
+	gen_require(`
+		attribute svirt_sandbox_domain;
+		type svirt_sandbox_file_t;
 	')
 
 	files_search_pids($1)
-	filetrans_pattern($1, virt_var_run_t, $2, $3, $4)
+	stream_connect_pattern($1, svirt_sandbox_file_t, svirt_sandbox_file_t, svirt_sandbox_domain)
+	ps_process_pattern(svirt_sandbox_domain, $1)
 ')
 
 ########################################
 ## <summary>
-##	Read virt log files.
+##	Execute qemu in the svirt domain, and
+##	allow the specified role the svirt domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed access
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	The role to be allowed the sandbox domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
-interface(`virt_read_log',`
+interface(`virt_transition_svirt',`
 	gen_require(`
-		type virt_log_t;
+		attribute virt_domain;
+		type virt_bridgehelper_t;
+		type svirt_image_t;
+		type svirt_socket_t;
 	')
 
-	logging_search_logs($1)
-	read_files_pattern($1, virt_log_t, virt_log_t)
+	allow $1 virt_domain:process transition;
+	role $2 types virt_domain;
+	role $2 types virt_bridgehelper_t;
+	role $2 types svirt_socket_t;
+
+	allow $1 virt_domain:process { sigkill sigstop signull signal };
+	allow $1 svirt_image_t:file { relabelfrom relabelto };
+	allow $1 svirt_image_t:fifo_file { read_fifo_file_perms relabelto };
+	allow $1 svirt_image_t:sock_file { create_sock_file_perms relabelto };
+	allow $1 svirt_socket_t:unix_stream_socket create_stream_socket_perms;
+
+	optional_policy(`
+		ptchown_run(virt_domain, $2)
+	')
 ')
 
 ########################################
 ## <summary>
-##	Append virt log files.
+##	Do not audit attempts to write virt daemon unnamed pipes.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`virt_dontaudit_write_pipes',`
+	gen_require(`
+		type virtd_t;
+	')
+
+	dontaudit $1 virtd_t:fd use;
+	dontaudit $1 virtd_t:fifo_file write_fifo_file_perms;
+')
+
+########################################
+## <summary>
+##	Send a sigkill to virtual machines
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -935,19 +961,17 @@ interface(`virt_read_log',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_append_log',`
+interface(`virt_kill_svirt',`
 	gen_require(`
-		type virt_log_t;
+		attribute virt_domain;
 	')
 
-	logging_search_logs($1)
-	append_files_pattern($1, virt_log_t, virt_log_t)
+	allow $1 virt_domain:process sigkill;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt log files.
+##	Send a sigkill to virtd daemon.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -955,20 +979,17 @@ interface(`virt_append_log',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_log',`
+interface(`virt_kill',`
 	gen_require(`
-		type virt_log_t;
+		type virtd_t;
 	')
 
-	logging_search_logs($1)
-	manage_dirs_pattern($1, virt_log_t, virt_log_t)
-	manage_files_pattern($1, virt_log_t, virt_log_t)
-	manage_lnk_files_pattern($1, virt_log_t, virt_log_t)
+	allow $1 virtd_t:process sigkill;
 ')
 
 ########################################
 ## <summary>
-##	Search virt image directories.
+##	Send a signal to virtual machines
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -976,18 +997,17 @@ interface(`virt_manage_log',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_search_images',`
+interface(`virt_signal_svirt',`
 	gen_require(`
-		attribute virt_image_type;
+		attribute virt_domain;
 	')
 
-	virt_search_lib($1)
-	allow $1 virt_image_type:dir search_dir_perms;
+	allow $1 virt_domain:process signal;
 ')
 
 ########################################
 ## <summary>
-##	Read virt image files.
+##	Manage virt home files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -995,36 +1015,57 @@ interface(`virt_search_images',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_read_images',`
+interface(`virt_manage_home_files',`
 	gen_require(`
-		type virt_var_lib_t;
-		attribute virt_image_type;
+		type virt_home_t;
 	')
 
-	virt_search_lib($1)
-	allow $1 virt_image_type:dir list_dir_perms;
-	list_dirs_pattern($1, virt_image_type, virt_image_type)
-	read_files_pattern($1, virt_image_type, virt_image_type)
-	read_lnk_files_pattern($1, virt_image_type, virt_image_type)
-	read_blk_files_pattern($1, virt_image_type, virt_image_type)
+	userdom_search_user_home_dirs($1)
+	manage_files_pattern($1, virt_home_t, virt_home_t)
+')
 
-	tunable_policy(`virt_use_nfs',`
-		fs_list_nfs($1)
-		fs_read_nfs_files($1)
-		fs_read_nfs_symlinks($1)
+########################################
+## <summary>
+##	allow domain to read
+##	virt tmpfs files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access
+##	</summary>
+## </param>
+#
+interface(`virt_read_tmpfs_files',`
+	gen_require(`
+		attribute virt_tmpfs_type;
 	')
 
-	tunable_policy(`virt_use_samba',`
-		fs_list_cifs($1)
-		fs_read_cifs_files($1)
-		fs_read_cifs_symlinks($1)
+	allow $1 virt_tmpfs_type:file read_file_perms;
+')
+
+########################################
+## <summary>
+##	allow domain to manage
+##	virt tmpfs files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access
+##	</summary>
+## </param>
+#
+interface(`virt_manage_tmpfs_files',`
+	gen_require(`
+		attribute virt_tmpfs_type;
 	')
+
+	allow $1 virt_tmpfs_type:file manage_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Read and write all virt image
-##	character files.
+##	Create .virt directory in the user home directory
+##	with an correct label.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1032,20 +1073,28 @@ interface(`virt_read_images',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_rw_all_image_chr_files',`
+interface(`virt_filetrans_home_content',`
 	gen_require(`
-		attribute virt_image_type;
+		type virt_home_t;
+		type svirt_home_t;
 	')
 
-	virt_search_lib($1)
-	allow $1 virt_image_type:dir list_dir_perms;
-	rw_chr_files_pattern($1, virt_image_type, virt_image_type)
+	userdom_user_home_dir_filetrans($1, virt_home_t, dir, ".libvirt")
+	userdom_user_home_dir_filetrans($1, virt_home_t, dir, ".virtinst")
+	filetrans_pattern($1, virt_home_t, svirt_home_t, dir, "qemu")
+
+	optional_policy(`
+		gnome_config_filetrans($1, virt_home_t, dir, "libvirt")
+		gnome_cache_filetrans($1, virt_home_t, dir, "libvirt")
+		gnome_cache_filetrans($1, virt_home_t, dir, "libvirt-sandbox")
+		gnome_cache_filetrans($1, virt_home_t, dir, "gnome-boxes")
+		gnome_data_filetrans($1, svirt_home_t, dir, "images")
+	')
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	svirt cache files.
+##	Dontaudit attempts to Read virt_image_type devices.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1053,37 +1102,133 @@ interface(`virt_rw_all_image_chr_files',
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_svirt_cache',`
-	refpolicywarn(`$0($*) has been deprecated, use virt_manage_virt_cache() instead.')
-	virt_manage_virt_cache($1)
+interface(`virt_dontaudit_read_chr_dev',`
+	gen_require(`
+		attribute virt_image_type;
+	')
+
+	dontaudit $1 virt_image_type:chr_file read_chr_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt cache content.
+##	Creates types and rules for a basic
+##	virt_lxc process domain.
 ## </summary>
-## <param name="domain">
+## <param name="prefix">
+##	<summary>
+##	Prefix for the domain.
+##	</summary>
+## </param>
+#
+template(`virt_sandbox_domain_template',`
+	gen_require(`
+		attribute svirt_sandbox_domain;
+	')
+
+	type $1_t, svirt_sandbox_domain;
+	domain_type($1_t)
+	domain_user_exemption_target($1_t)
+	mls_rangetrans_target($1_t)
+	mcs_constrained($1_t)
+	role system_r types $1_t;
+
+	logging_send_syslog_msg($1_t)
+
+	kernel_read_system_state($1_t)
+')
+
+########################################
+## <summary>
+##	Make the specified type usable as a lxc domain
+## </summary>
+## <param name="type">
 ##	<summary>
+##	Type to be used as a lxc domain
+##	</summary>
+## </param>
+#
+template(`virt_sandbox_domain',`
+	gen_require(`
+		attribute svirt_sandbox_domain;
+	')
+
+	typeattribute  $1 svirt_sandbox_domain;
+')
+
+########################################
+## <summary>
+##	Execute a qemu_exec_t in the callers domain
+## </summary>
+## <param name="domain">
+## <summary>
 ##	Domain allowed access.
+## </summary>
+## </param>
+#
+interface(`virt_exec_qemu',`
+	gen_require(`
+		type qemu_exec_t;
+	')
+
+	can_exec($1, qemu_exec_t)
+')
+
+########################################
+## <summary>
+##	Transition to virt named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_virt_cache',`
+interface(`virt_filetrans_named_content',`
 	gen_require(`
-		type virt_cache_t;
+		type virt_lxc_var_run_t;
+		type virt_var_run_t;
 	')
 
-	files_search_var($1)
-	manage_dirs_pattern($1, virt_cache_t, virt_cache_t)
-	manage_files_pattern($1, virt_cache_t, virt_cache_t)
-	manage_lnk_files_pattern($1, virt_cache_t, virt_cache_t)
+	files_pid_filetrans($1, virt_lxc_var_run_t, dir, "libvirt-sandbox")
+	files_pid_filetrans($1, virt_var_run_t, dir, "libvirt")
+	files_pid_filetrans($1, virt_var_run_t, dir, "libguestfs")
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	virt image files.
+##	Execute qemu in the svirt domain, and
+##	allow the specified role the svirt domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	The role to be allowed the sandbox domain.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`virt_transition_svirt_sandbox',`
+	gen_require(`
+		attribute svirt_sandbox_domain;
+	')
+
+	allow $1 svirt_sandbox_domain:process { transition signal_perms };
+	role $2 types svirt_sandbox_domain;
+	allow $1 svirt_sandbox_domain:unix_dgram_socket sendto;
+
+	allow svirt_sandbox_domain $1:fifo_file rw_fifo_file_perms;
+	allow svirt_sandbox_domain $1:process sigchld;
+	ps_process_pattern($1, svirt_sandbox_domain)
+')
+
+########################################
+## <summary>
+##	Read and write to svirt_image devices.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1091,36 +1236,54 @@ interface(`virt_manage_virt_cache',`
 ##	</summary>
 ## </param>
 #
-interface(`virt_manage_images',`
+interface(`virt_rw_svirt_dev',`
 	gen_require(`
-		type virt_var_lib_t;
-		attribute virt_image_type;
+		type svirt_image_t;
 	')
 
-	virt_search_lib($1)
-	allow $1 virt_image_type:dir list_dir_perms;
-	manage_dirs_pattern($1, virt_image_type, virt_image_type)
-	manage_files_pattern($1, virt_image_type, virt_image_type)
-	read_lnk_files_pattern($1, virt_image_type, virt_image_type)
-	rw_blk_files_pattern($1, virt_image_type, virt_image_type)
+	allow $1 svirt_image_t:chr_file rw_file_perms;
+')
 
-	tunable_policy(`virt_use_nfs',`
-		fs_manage_nfs_dirs($1)
-		fs_manage_nfs_files($1)
-		fs_read_nfs_symlinks($1)
+########################################
+## <summary>
+##	Read and write to svirt_image devices.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`virt_rlimitinh',`
+	gen_require(`
+		type virtd_t;
 	')
 
-	tunable_policy(`virt_use_samba',`
-		fs_manage_cifs_files($1)
-		fs_manage_cifs_files($1)
-		fs_read_cifs_symlinks($1)
+    allow $1 virtd_t:process { rlimitinh };
+')
+
+########################################
+## <summary>
+##	Read and write to svirt_image devices.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`virt_noatsecure',`
+	gen_require(`
+		type virtd_t;
 	')
+
+    allow $1 virtd_t:process { noatsecure rlimitinh };
 ')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an virt environment.
+##	All of the rules required to administrate
+##	an virt environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -1136,50 +1299,36 @@ interface(`virt_manage_images',`
 #
 interface(`virt_admin',`
 	gen_require(`
-		attribute virt_domain, virt_image_type, virt_tmpfs_type;
-		attribute virt_ptynode, svirt_lxc_domain, virt_tmp_type;
-		type virtd_t, virtd_initrc_exec_t, virtd_lxc_t;
-		type virsh_t, virtd_lxc_var_run_t, svirt_lxc_file_t;
-		type virt_bridgehelper_t, virt_qmf_t, virt_var_lib_t;
-		type virt_var_run_t, virt_tmp_t, virt_log_t;
-		type virt_lock_t, svirt_var_run_t, virt_etc_rw_t;
-		type virt_etc_t, svirt_cache_t, virtd_keytab_t;
+		attribute virt_domain;
+		attribute virt_system_domain;
+		attribute svirt_file_type;
+		attribute virt_file_type;
+		type virtd_initrc_exec_t;
 	')
 
-	allow $1 { virt_domain svirt_lxc_domain virtd_t }:process { ptrace signal_perms };
-	allow $1 { virtd_lxc_t virsh_t virt_bridgehelper_t virt_qmf_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { virt_domain svirt_lxc_domain virtd_t })
-	ps_process_pattern($1, { virtd_lxc_t virsh_t virt_bridgehelper_t virt_qmf_t })
+	allow $1 virt_system_domain:process signal_perms;
+	allow $1 virt_domain:process signal_perms;
+	ps_process_pattern($1, virt_system_domain)
+	ps_process_pattern($1, virt_domain)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 virt_system_domain:process ptrace;
+		allow $1 virt_domain:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, virtd_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 virtd_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	fs_search_tmpfs($1)
-	admin_pattern($1, virt_tmpfs_type)
-
-	files_search_tmp($1)
-	admin_pattern($1, { virt_tmp_type virt_tmp_t })
-
-	files_search_etc($1)
-	admin_pattern($1, { virt_etc_t virt_etc_rw_t virtd_keytab_t })
-
-	logging_search_logs($1)
-	admin_pattern($1, virt_log_t)
-
-	files_search_pids($1)
-	admin_pattern($1, { virt_var_run_t virtd_lxc_var_run_t svirt_var_run_t })
+	allow $1 virt_domain:process signal_perms;
 
-	files_search_var($1)
-	admin_pattern($1, svirt_cache_t)
-
-	files_search_var_lib($1)
-	admin_pattern($1, { virt_image_type virt_var_lib_t svirt_lxc_file_t })
+	admin_pattern($1, virt_file_type)
+	admin_pattern($1, svirt_file_type)
 
-	files_search_locks($1)
-	admin_pattern($1, virt_lock_t)
+	virt_systemctl($1)
+	allow $1 virtd_unit_file_t:service all_service_perms;
 
-	dev_list_all_dev_nodes($1)
-	allow $1 virt_ptynode:chr_file rw_term_perms;
+	virt_stream_connect_sandbox($1)
+	virt_stream_connect_svirt($1)
+	virt_stream_connect($1)
 ')
